# import com_picockpit.constants as CONST
# from picockpit_client.pmqtt import PCPMQTTClient as PCPMQTTClient
from com_picockpit.gpio.gpio_pin_io import GpioPinIO as GpioPinIO


class ComPicockpitGPIO:
    def __init__(self, global_run_flag, hooks):
        self.global_run_flag = global_run_flag
        self.gpio_pins = {}
        for bcm_id in range(0, 46):
            self.gpio_pins[bcm_id] = GpioPinIO(
                bcm_id=bcm_id,
                hooks=hooks)

    def on_connect_hook(self):
        for bcm_id in range(0, 46):
            self.gpio_pins[bcm_id].on_connect_hook()

    def reload_hook(self):
        # TODO: Implementation ?
        pass

    def on_disconnect_hook(self):
        for bcm_id in range(0, 46):
            self.gpio_pins[bcm_id].on_disconnect_hook()

    def timer_hook(self, timer_spacing):
        pass

    def update_pin(self, bcm_id, mode):
        if bcm_id in self.gpio_pins:
            self.gpio_pins[bcm_id].setup(mode)

    def teardown_pin(self, bcm_id):
        if bcm_id in self.gpio_pins:
            self.gpio_pins[bcm_id].tear_down()
